import 'package:flutter/material.dart';
import 'package:flutter_form_builder/flutter_form_builder.dart';

class AddStoreView extends StatefulWidget {
static final routePath = '/AddStoreView';

  @override
  AddStoreViewState createState() {
    return AddStoreViewState();
  }
}

class AddStoreViewState extends State<AddStoreView> {
  var data;
  bool autoValidate = true;
  bool readOnly = false;
  bool showSegmentedControl = true;

  @override
  Widget build(BuildContext context) {

    const allCountries = [
      "Afghanistan",
      "Albania",
      "Algeria",
      "American Samoa",
      "Andorra",
      "Angola",
      "Anguilla",
      "Antarctica",
      "Antigua and Barbuda",
      "Argentina",
      "Armenia",
      "Aruba",
      "Australia",
      "Austria",
      "Autre",
      "Azerbaijan",
      "Bahamas",
      "Bahrain",
      "Bangladesh",
      "Barbados",
      "Belarus",
      "Belgium",
      "Belize",
      "Benin",
      "Bermuda",
      "Bhutan",
      "Bolivia",
      "Bosnia and Herzegowina",
      "Botswana",
      "Bouvet Island",
      "Brazil",
      "British Indian Ocean Territory",
      "Brunei Darussalam",
      "Bulgaria",
      "Burkina Faso",
      "Burundi",
      "Cambodia",
      "Cameroon",
      "Canada",
      "Cape Verde",
      "Cayman Islands",
      "Central African Republic",
      "Chad",
      "Chile",
      "China",
      "Christmas Island",
      "Cocos (Keeling) Islands",
      "Colombia",
      "Comoros",
      "Congo",
      "Congo, the Democratic Republic of the",
      "Cook Islands",
      "Costa Rica",
      "Cote d'Ivoire",
      "Croatia (Hrvatska)",
      "Cuba",
      "Cyprus",
      "Czech Republic",
      "Denmark",
      "Djibouti",
      "Dominica",
      "Dominican Republic",
      "East Timor",
      "Ecuador",
      "Egypt",
      "El Salvador",
      "Equatorial Guinea",
      "Eritrea",
      "Estonia",
      "Ethiopia",
      "Falkland Islands (Malvinas)",
      "Faroe Islands",
      "Fiji",
      "Finland",
      "France",
      "France Metropolitan",
      "French Guiana",
      "French Polynesia",
      "French Southern Territories",
      "Gabon",
      "Gambia",
      "Georgia",
      "Germany",
      "Ghana",
      "Gibraltar",
      "Greece",
      "Greenland",
      "Grenada",
      "Guadeloupe",
      "Guam",
      "Guatemala",
      "Guinea",
      "Guinea-Bissau",
      "Guyana",
      "Haiti",
      "Heard and Mc Donald Islands",
      "Holy See (Vatican City State)",
      "Honduras",
      "Hong Kong",
      "Hungary",
      "Iceland",
      "India",
      "Indonesia",
      "Iran (Islamic Republic of)",
      "Iraq",
      "Ireland",
      "Israel",
      "Italy",
      "Jamaica",
      "Japan",
      "Jordan",
      "Kazakhstan",
      "Kenya",
      "Kiribati",
      "Korea, Democratic People's Republic of",
      "Korea, Republic of",
      "Kuwait",
      "Kyrgyzstan",
      "Lao, People's Democratic Republic",
      "Latvia",
      "Lebanon",
      "Lesotho",
      "Liberia",
      "Libyan Arab Jamahiriya",
      "Liechtenstein",
      "Lithuania",
      "Luxembourg",
      "Macau",
      "Macedonia, The Former Yugoslav Republic of",
      "Madagascar",
      "Malawi",
      "Malaysia",
      "Maldives",
      "Mali",
      "Malta",
      "Marshall Islands",
      "Martinique",
      "Mauritania",
      "Mauritius",
      "Mayotte",
      "Mexico",
      "Micronesia, Federated States of",
      "Moldova, Republic of",
      "Monaco",
      "Mongolia",
      "Montserrat",
      "Morocco",
      "Mozambique",
      "Myanmar",
      "Namibia",
      "Nauru",
      "Nepal",
      "Netherlands",
      "Netherlands Antilles",
      "New Caledonia",
      "New Zealand",
      "Nicaragua",
      "Niger",
      "Nigeria",
      "Niue",
      "Norfolk Island",
      "Northern Mariana Islands",
      "Norway",
      "Oman",
      "Pakistan",
      "Palau",
      "Panama",
      "Papua New Guinea",
      "Paraguay",
      "Peru",
      "Philippines",
      "Pitcairn",
      "Poland",
      "Portugal",
      "Puerto Rico",
      "Qatar",
      "Reunion",
      "Romania",
      "Russian Federation",
      "Rwanda",
      "Saint Kitts and Nevis",
      "Saint Lucia",
      "Saint Vincent and the Grenadines",
      "Samoa",
      "San Marino",
      "Sao Tome and Principe",
      "Saudi Arabia",
      "Senegal",
      "Seychelles",
      "Sierra Leone",
      "Singapore",
      "Slovakia (Slovak Republic)",
      "Slovenia",
      "Solomon Islands",
      "Somalia",
      "South Africa",
      "South Georgia and the South Sandwich Islands",
      "Spain",
      "Sri Lanka",
      "St. Helena",
      "St. Pierre and Miquelon",
      "Sudan",
      "Suriname",
      "Svalbard and Jan Mayen Islands",
      "Swaziland",
      "Sweden",
      "Switzerland",
      "Syrian Arab Republic",
      "Taiwan, Province of China",
      "Tajikistan",
      "Tanzania, United Republic of",
      "Thailand",
      "Togo",
      "Tokelau",
      "Tonga",
      "Trinidad and Tobago",
      "Tunisia",
      "Turkey",
      "Turkmenistan",
      "Turks and Caicos Islands",
      "Tuvalu",
      "Uganda",
      "Ukraine",
      "United Arab Emirates",
      "United Kingdom",
      "United States",
      "United States Minor Outlying Islands",
      "Uruguay",
      "Uzbekistan",
      "Vanuatu",
      "Venezuela",
      "Vietnam",
      "Virgin Islands (British)",
      "Virgin Islands (U.S.)",
      "Wallis and Futuna Islands",
      "Western Sahara",
      "Yemen",
      "Yugoslavia",
      "Zambia",
      "Zimbabwe"
    ];
    GlobalKey<FormBuilderState> _fbKey = GlobalKey();
    return Scaffold(
      appBar: AppBar(
        title: Text('Configurer son magasin'),
      ),
      body: Container(
        margin: EdgeInsets.all(15.0),
        child: SingleChildScrollView(
          child: Column(
            children: <Widget>[
                FormBuilder(
                  context,
                  key: _fbKey,
                  autovalidate: autoValidate,
                  readonly: readOnly,
                  /*onChanged: (formValue) {
                    print(formValue);
                  },*/
                  controls: [
                  //  FormBuilderInput.chipsInput(
                  //    decoration: InputDecoration(labelText: "Chils"),
                  //    attribute: 'chips_test',
                  //    // require: true,
                  //    value: [
                  //      Contact('Andrew', 'stock@man.com',
                  //          'https://d2gg9evh47fn9z.cloudfront.net/800px_COLOURBOX4057996.jpg'),
                  //    ],
                  //    max: 1,
                  //    suggestionsCallback: (String query) {
                  //      if (query.length != 0) {
                  //        var lowercaseQuery = query.toLowerCase();
                  //        return mockResults.where((profile) {
                  //          return profile.name
                  //                  .toLowerCase()
                  //                  .contains(query.toLowerCase()) ||
                  //              profile.email
                  //                  .toLowerCase()
                  //                  .contains(query.toLowerCase());
                  //        }).toList(growable: false)
                  //          ..sort((a, b) => a.name
                  //              .toLowerCase()
                  //              .indexOf(lowercaseQuery)
                  //              .compareTo(b.name
                  //                  .toLowerCase()
                  //                  .indexOf(lowercaseQuery)));
                  //      } else {
                  //        return const <Contact>[];
                  //      }
                  //    },
                  //    chipBuilder: (context, state, profile) {
                  //      return InputChip(
                  //        key: ObjectKey(profile),
                  //        label: Text(profile.name),
                  //        avatar: CircleAvatar(
                  //          backgroundImage: NetworkImage(profile.imageUrl),
                  //        ),
                  //        onDeleted: () => state.deleteChip(profile),
                  //        materialTapTargetSize: MaterialTapTargetSize.shrinkWrap,
                  //      );
                  //    },
                  //    suggestionBuilder: (context, state, profile) {
                  //      return ListTile(
                  //        key: ObjectKey(profile),
                  //        leading: CircleAvatar(
                  //          backgroundImage: NetworkImage(profile.imageUrl),
                  //        ),
                  //        title: Text(profile.name),
                  //        subtitle: Text(profile.email),
                  //        onTap: () => state.selectSuggestion(profile),
                  //      );
                  //    },
                  //  ),
                    FormBuilderInput.textField(
                        type: FormBuilderInput.TYPE_TEXT,
                        attribute: "name",
                        decoration: InputDecoration(labelText: "Nom du magasin", icon: Icon(Icons.store)),
                        value: "Chez Mimi Confiserie",
                        require: true,
                        // readonly: true,
                        min: 2,
                        /*onChanged: (newVal) {
                          print(newVal);
                          print(_fbKey.currentState
                              .findFieldByAttribute("story")
                              .currentState
                              .value);
                          _fbKey.currentState
                              .findFieldByAttribute("story")
                              .currentState
                              .didChange(newVal);
                        }*/
                        ),
                    FormBuilderInput.dropdown(
                      attribute: "dropdown",
                      // require: true,
                      // icons dropdown use all that start ith local
                      decoration: InputDecoration(labelText: "Type de commerce" , icon: Icon(Icons.category)),
                      options: [
                        FormBuilderInputOption(value: "Poissonnerie"),
                        FormBuilderInputOption(value: "Boulangerie"),
                        FormBuilderInputOption(value: "Boutique alimentaire"),
                        FormBuilderInputOption(value: "Autre")
                      ],
                    ),

                    
                    FormBuilderInput.textField(
                      type: FormBuilderInput.TYPE_PHONE,
                      attribute: "phone",
                      decoration: InputDecoration(labelText: "Telephone", icon : Icon(Icons.phone)),
                      //require: true,
                    ),
                    FormBuilderInput.textField(
                      type: FormBuilderInput.TYPE_PHONE,
                      attribute: "phone",
                      decoration: InputDecoration(labelText: "Whatsapp", icon: ImageIcon(AssetImage('whatsapp.svg'))),
                      //require: true,
                    ),
                    FormBuilderInput.textField(
                      type: FormBuilderInput.TYPE_EMAIL,
                      attribute: "email",
                      decoration: InputDecoration(labelText: "Email", icon: Icon(Icons.alternate_email)),
                      validator: (value) {
                                if (value.isEmpty) {
                                  return 'Ecrire l\'adresse email';
                                }
                              },
                      //require: true,
                    ),
                    FormBuilderInput.textField(
                      type: FormBuilderInput.TYPE_URL,
                      attribute: "url",
                      decoration: InputDecoration(labelText: "Website", icon: Icon(Icons.http)),
                      //require: true,
                    ),
                  
                    FormBuilderInput.datePicker(
                      decoration: InputDecoration(labelText: "Date", icon: Icon(Icons.today)),
                      readonly: true,
                      attribute: "dob",
                      firstDate: DateTime(1970),
                      value: DateTime.now(),
                      lastDate: DateTime.now().add(Duration(days: 1)),
                      format: 'yyyy, MM, dd',
                    ),
                    FormBuilderInput.typeAhead(
                      decoration: InputDecoration(labelText: "Pays", icon: Icon(Icons.language)),
                      attribute: 'country',
                      value: 'Senegal',
                      // require: true,
                      itemBuilder: (context, country) {
                        return ListTile(
                          title: Text(country),
                        );
                      },
                      suggestionsCallback: (query) {
                        if (query.length != 0) {
                          var lowercaseQuery = query.toLowerCase();
                          return allCountries.where((country) {
                            return country.toLowerCase().contains(lowercaseQuery);
                          }).toList(growable: false)
                            ..sort((a, b) => a
                                .toLowerCase()
                                .indexOf(lowercaseQuery)
                                .compareTo(
                                    b.toLowerCase().indexOf(lowercaseQuery)));
                        } else {
                          return allCountries;
                        }
                      },
                    ),
                    //FormBuilderInput.timePicker(
                    //  decoration: InputDecoration(labelText: "Alarm Time"),
                    //  attribute: "alarm",
                      //require: true,
                    //),
                    //FormBuilderInput.dateTimePicker(
                    //  decoration: InputDecoration(labelText: "Appointment Time"),
                    //  attribute: "appointment_time",
                    //  firstDate: DateTime(1970),
                    //  lastDate: DateTime.now().add(Duration(days: 1)),
                    // format: 'dd, MM yyyy hh:mm',
                    //),

                    // If this answer is different from x1 then this could be good 
                    //FormBuilderInput.radio(
                    //  decoration:
                    //      InputDecoration(labelText: 'My chosen language'),
                    //  attribute: "best_language",
                    //  require: true,
                    //  options: ["Dart", "Kotlin", "Java", "Swift", "Objective-C"]
                    //      .map((lang) => FormBuilderInputOption(value: lang))
                    //      .toList(growable: false),
                    //),
                    FormBuilderInput.checkbox(
                        label: Text('J\'ai lu et accepte les termes et conditions'),
                        attribute: "accept_terms",
                        validator: (value) {
                          if (!value) return "Accepter les termes et conditions pour continuer";
                        }),
                    // FormBuilderInput.switchInput(
                    //     label: Text('I Accept the tems and conditions'),
                    //     attribute: "accept_terms_switch",
                    //     value: true,
                    //     validator: (value) {
                    //       if (!value) return "Accept terms to continue";
                    //     }),
                    //FormBuilderInput.slider(
                    //  decoration: InputDecoration(labelText: "Slider"),
                    //  attribute: "slider",
                    //  min: 0.0,
                    //  require: true,
                    //  max: 100.0,
                    //  value: 10.0,
                    //  divisions: 20,
                    //),
                    //FormBuilderInput.stepper(
                    //  decoration: InputDecoration(labelText: "Stepper"),
                    //  attribute: "stepper",
                    //  value: 10,
                    //  step: 1,
                    //),
                    // FormBuilderInput.signaturePad(
                    //   decoration: InputDecoration(labelText: "Signature"),
                    //   attribute: "signature",
                    //   height: 100,
                    //   require: true,
                    // ),
                    //FormBuilderInput.rate(
                    //  decoration: InputDecoration(labelText: "Rate this form"),
                    //  attribute: "rate",
                    //  iconSize: 32.0,
                    //  value: 1,
                    //  max: 5,
                    //),
                    // showSegmentedControl ? FormBuilderInput.segmentedControl(
                    //   decoration:
                    //       InputDecoration(labelText: "Movie Rating (Archer)"),
                    //   attribute: "movie_rating",
                    //   // value: 2,
                    //   require: true,
                    //   options: List.generate(5, (i) => i + 1)
                    //       .map((number) => FormBuilderInputOption(value: number))
                    //       .toList(),
                    // ) : null,
                  ],
              ),
              MaterialButton(
                child: Text('Enregistrer'),
                onPressed: () {
                  _fbKey.currentState.save();
                  if (_fbKey.currentState.validate()) {
                    print('ok');
                    print(_fbKey.currentState.value);
                  } else {
                    print("erreur");
                  }
                },
              ),
            ],
          ),
        ),
      ),
    );
  }
}




//final emailController = TextEditingController();
//  final passwordController = TextEditingController();
//  final int id = 1;
//  final String deviceUuid = '123456789'; //IconData tablet_android
//  final String name = 'Aywadjieune'; //
//  final String ownerName = 'Malick Birane';
//  final String email = 'info@Aywadjieune.com';
//  final String telephone = '221784578488';
//  final String telephone2 = '';
//  final String telephone3 = '';
//  final String whatsapp = '';
//  final String calendar = 'calendarName';
//  final String type = 'poissonnerie';
//  final String country = 'Sénégal';
//  final String address = 'Dakar';
//  final String latitude = '-156789';
//  final String longitude = '12340';
//  final String logo = '/logo.png';
//  final String printedLogo = '/reformatedlogo.png';
//  final String language = 'FR'; Icon.language
//  final String currency = 'CFA';
//  final String legalNumber = 'RC...';
//  final String taxNumber = '';
//  final String accountingCode ='' ;
//  final String accountingInfo ='' ;
//  final int date = 0;
//  final int dateEdit = 0 ;
//  final int dateStop = 0 ;
//  final int status = 1 ;